/*(c)Copyright 1995,2001 by Paul Shields, all rights reserved.
  Please read the file LICENSE distributed with this source code.*/

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "parse.h"

#define BUFFER_SIZE ((MAX_WORDS)*20)

static char buf[BUFFER_SIZE];
static char *words[MAX_WORDS];

int fparse( FILE *fp, int *numwp, char **wp[] ) {
  int i,j,k,m,s;
  char *p;
  for(i=0,j=0; i<BUFFER_SIZE && !feof(fp); i++) {
    /*printf("%d,%d\n",i,j);*/
    p=fgets(&buf[i], BUFFER_SIZE-i, fp);
    if( p ) {
      i += (strlen(p)+1);

      /* break into words according to non-letter characters */
      while( *p ) {
         while( *p && !isalpha(*p) )
           p++;
         if( *p ) {
           words[j]=p;
           while( *p && isalpha(*p) ) 
	     p++;
           if( *p )
             *p++ = 0;
           j++;
         }
         if( j>=MAX_WORDS ) {
	   *numwp = MAX_WORDS; 
	   *wp = words;
	   return -1;
	 }
      }
    }
  }

  *numwp = j;
  *wp = words;
  return 0;
}
