/* (c)Copyright 1995,2001 by Paul Shields, all rights reserved.
   Please read the file LICENSE distributed with this source code. */

/* randline.c - Return a random line in a file.
   randline file [file ...]
 */
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

#define LSIZE  512       /* max line len */

char line[LSIZE];

main(argc,argv)
int argc;
char *argv[];
{
  int i;
  FILE *fp;
  long fz,r,r1;

  srand(time(0));

  if(argc < 2)
    {
      fprintf(stderr,"Select a random line in a text file..\n");
      fprintf(stderr,"usage: %s file ...\n",argv[0]);
    }
  for(i=1; i<argc; i++)
      if((fp = fopen(argv[i],"r"))==NULL) 
	  perror(argv[i]);
      else
	{
	  fseek(fp,0,2);      /* find file size */
	  fz = ftell(fp);

#ifdef DEBUG
	  fprintf(stderr,"fsize=%ld\n",fz);
#endif

	  /* select a file offset */
	  r1=((long)(rand() & 0x7ff0) << 7L) + (((long)rand() & 0x7ff0) >> 4L);
	  r = (r1 * 1.0 * fz / 4194304.0);

#ifdef DEBUG
	  fprintf(stderr,"rand=%ld,%ld\n",r1,r);
#endif
	
	  fseek(fp,r,0);          /* go to random place in file */

	  if(r > 0)               /* skip to next whole line */
	    fgets(line,LSIZE,fp); /* discard partial line */

	  if(feof(fp) || ftell(fp)==fz)
	     fseek(fp,0,0);       /* wrap around to beginning if needed */

	  fgets(line,LSIZE,fp);   /* print it */
	  fputs(line,stdout);

	  fclose(fp);
	}
}
